-- Main Driver

do
	
	-- Utilities
	u = require('lib.utils')
	
	-- Driver Global
	_D = {
		debug = false
	}
	
end

-- Properties

function OnPropertyChanged(strProperty)

	u.debug("OnPropertyChanged (" .. strProperty .. ")")

	-- Debug Mode
	if strProperty == "Debug Mode" then

		_D.debug = Properties[strProperty] == "On"
	
		u.console("Debug Mode Turned " .. Properties[strProperty])
	
	end
	
end

function ExecuteCommand(strCommand, tParams)
	
	u.debug("ExecuteCommand (" .. strCommand .. ")")
	
	if tParams then
		for i,v in pairs(tParams) do 
			if type(v) == "table" then
				u.debug(" Parameter: " .. i .. " = Table")
			else
				u.debug(" Parameter: " .. i .. " = " .. v)
			end
		end
	end
	
	-- Lua Window Action
	if (strCommand == "LUA_ACTION") then
		
		-- Test Mail
		if tParams.ACTION == "TEST_MAIL" then
			
			if  Properties["Email Address"] == "" then
				u.console("Email Address Missing")
				return
			end
			
			local tParams = {
				SERVER = Properties["SMTP Server"],
				PORT = Properties["SMTP Port"],
				USERNAME = Properties["SMTP Username"],
				PASSWORD = Properties["SMTP Password"],
				FROM_ADDRESS = Properties["SMTP Username"],
				FROM_NAME = C4:GetUniqueMAC(),
				TO = Properties["Email Address"],
				CC = nil,
				BCC = nil,
				SUBJECT = Properties["Subject"],
				MESSAGE = Properties["Message To Send"],
				ID = C4:GetDeviceID(),
				DEBUG = true
			}
	
			local url = Properties["Attachment URL"]

			-- Send Email Or Retrieve URL If Set Then Send
			if url == "" then
				C4:SendToProxy(999, "SMTP_SENDMAIL", tParams)
			else
				C4:url()
				:OnDone(function (transfer, responses, error, message)
					if error == 0 and responses and responses[#responses] and responses[#responses].body then
						tParams.ATTACHMENT_NAME = Properties["Attachment Name"]
						tParams.ATTACHMENT_BODY = C4:Base64Encode(responses[#responses].body)
						tParams.MESSAGE         = tParams.MESSAGE .. "\r\n\r\n"
					end
					C4:SendToProxy(999, "SMTP_SENDMAIL", tParams)
				end)
				:Get(url)
			end
			
		end

	-- SMTP Response
	elseif strCommand == "SMTP_RESPONSE" then
	
		u.console(tParams.status)
		u.console(tParams.debug)
		
	end
	
end